/* This file was generated by scramble.py. */
#line 1 "src/game.py"
#include "game.h"
#line 32
Game * game;
#line 34
bool flag;
static void _set_flag(Trees * trees, Tree * tree, float dx, float dy);
static bool _draw(float mx, float my);
static float _letterbox(float * w, float * h);
static void _set_flag(Trees * trees, Tree * tree, float dx, float dy) {
    flag = 1;
}
void music(str name) {
    land_stream_music_once(game->music, name);
}
void game_init(void) {
    land_display_title("Dr. Forest");
    land_alloc(game);
#line 45
    game->music = land_stream_new(2048, 4, 44100, 16, 2);
#line 47
    game->splash = land_sound_load("data/splash.ogg");
    game->frog = land_sound_load("data/frog.ogg");
    game->fire = land_sound_load("data/fire.ogg");
    game->tree = land_sound_load("data/tree.ogg");
    game->wind = land_sound_load("data/wind.ogg");
#line 53
    game->trees = trees_new();
    game->camera_angle = pi / (- 3.3);
#line 56
    reload_font(1);
#line 58
    game_restart_level(1);
}
void game_restart_level(int number) {
    if (game->world) {
#line 61
        world_destroy(game->world);
    }
#line 62
    trees_clear(game->trees);
    game->world = world_new();
    if (number == 0) {
#line 64
        number = game->level->number;
    }
#line 65
    game->level = levels_start(number);
}
static bool _draw(float mx, float my) {
    float dx = mx - game->lx;
    float dy = my - game->ly;
    if (game->level->tools [game->tool] == 0) {
#line 70
        return 0;
    }
#line 71
    if (dx * dx + dy * dy > 10) {
        game->lx = mx;
        game->ly = my;
        if (game->level->tools [game->tool] > 0) {
            game->level->tools [game->tool]--;
        }
#line 76
        return 1;
    }
#line 77
    return 0;
}
Tree* place_tree_rising(float x, float y, str kind, bool rising) {
    flag = 0;
    trees_callback(game->trees, x, y, 30, _set_flag);
    if (flag) {
#line 82
        return NULL;
    }
#line 83
    return place_tree_rising_nc(x, y, kind, rising, 1);
}
Tree* place_tree_rising_nc(float x, float y, str kind, bool rising, bool blotch) {
    float z = rising ? - 99 : world_get_altitude(game->world, x, y);
    Tree * tree = trees_make(game->trees, kind, x, y, z);
    if (blotch) {
        world_blotch(game->world, x, y, 40, land_color_rgba(0.3, 0.1, 0, 1));
    }
#line 90
    tree->rising = rising;
    return tree;
}
Tree* place_tree(float x, float y, str kind) {
    return place_tree_rising(x, y, kind, 0);
}
void reload_font(float s) {
    if (game->font) {
#line 97
        land_font_destroy(game->font);
    }
#line 98
    int si = 32 / s;
    game->font = land_font_load("data/JosefinSans-Regular.ttf", si);
    land_font_scale(game->font, 32.0 / si);
    land_font_yscale(game->font, - 32.0 / si);
}
void game_tick(void) {
    float dw = land_display_width();
    float dh = land_display_height();
    float w, h;
    _letterbox(& w, & h);
#line 109
    if (land_was_resized()) {
        game->resizing = 1;
    }
    if (land_closebutton()) {
#line 112
        land_quit();
    }
#line 113
    if (land_key_pressed(LandKeyEscape)) {
#line 113
        land_quit();
    }
    float mx = (land_mouse_x() - dw / 2) * w / dw;
    float my = (dh / 2 - land_mouse_y()) * h / dh;
#line 118
    LandVector t;
    if (1) {
        LandVector v = land_vector(mx, my, 0);
        LandVector p = land_vector(0, 0, 0);
        LandVector x = land_vector(1, 0, 0);
        LandVector y = land_vector(0, 1, 0);
        LandVector z = land_vector(0, 0, 1);
        Land4x4Matrix rot = land_4x4_matrix_rotate(1, 0, 0, game->camera_angle);
        x = land_vector_matmul(x, & rot);
        y = land_vector_matmul(y, & rot);
        z = land_vector_matmul(z, & rot);
        t = land_vector_backtransform(v, p, x, y, z);
#line 131
        LandFloat e = - t.z / z.z;
        t.x += z.x * e;
        t.y += z.y * e;
        t.z = world_get_altitude(game->world, t.x, t.y);
#line 136
        LandVector t_ = land_vector_transform(t, p, x, y, z);
        t_.z = 0;
        float d = land_vector_norm(land_vector_sub(v, t_));
#line 140
        LandVector t2 = t;
        for (int i = 0; i < 100; i += 1) {
            LandVector t2_ = land_vector_transform(t2, p, x, y, z);
            t2_.z = 0;
            float d2 = land_vector_norm(land_vector_sub(v, t2_));
            if (d2 > d) {
#line 145
                break;
            }
#line 146
            d = d2;
            t = t2;
            t2.y -= 10;
            t2.z = - world_get_altitude(game->world, t2.x, t2.y) /* why -?? */;
        }
    }
#line 151
    if (land_mouse_button_clicked(0)) {
        if (mx < - 420) {
            int tool = (h / 2 - my) / 60;
            if (tool == 6) {
                if (game->paused) {
                    game->won = 0;
                    pause_toggle();
                }
#line 158
                game_restart_level(0);
            }
#line 159
            else if (tool == 7) {
                pause_toggle();
            }
#line 160
            else {
#line 162
                game->tool = tool;
            }
        }
    }
#line 164
    if (game->paused) {
        if (land_key_pressed(LandKeyBackspace)) {
            game->level->number -= 2;
            game->won = 1;
            pause_toggle();
        }
#line 169
        if (land_key_pressed(LandKeyEnter)) {
            game->won = 1;
            pause_toggle();
        }
#line 172
        trees_dance(game->trees);
        funky(0);
#line 173
        return ;
    }
#line 176
    int tick = land_get_ticks();
#line 178
    levels_tick();
#line 180
    if (land_mouse_button(0)) {
        if (mx < - 420) {
#line 181
            ;
        }
        else if (game->tool == 1) {
            if (_draw(mx, my)) {
                world_blotch(game->world, t.x, t.y, 50, land_color_rgba(1, 0.8, 0.6, 1));
                trees_callback(game->trees, t.x, t.y, 60, tree_whirl);
                if (tick > game->wind_t) {
                    game->wind_t = tick + 15;
                    land_sound_play(game->wind, 1, 0, land_rnd(1, 1.25));
                }
            }
        }
#line 190
        else if (game->tool == 0) {
            if (_draw(mx, my)) {
                world_patch(game->world, t.x, t.y, 40, land_color_rgba(0.2, 0.4, 0.4, 1));
                trees_callback_square(game->trees, t.x, t.y, 50, tree_water);
                if (tick > game->splash_t) {
                    game->splash_t = tick + 40;
                    land_sound_play(game->splash, 1, 0, 1);
                }
            }
        }
#line 197
        else if (game->tool == 2) {
            if (_draw(mx, my)) {
                trees_callback(game->trees, t.x, t.y, 60, tree_burn);
                world_blotch(game->world, t.x, t.y, 40, land_color_rgba(0, 0, 0, 1));
            }
        }
#line 201
        else if (game->tool == 3) {
            if (_draw(mx, my)) {
                place_tree_rising(t.x, t.y, "oak", 1);
                if (! land_rand(0, 2)) {
                    place_tree_rising_nc(t.x, t.y, "beetle", 1, 0);
                }
            }
        }
#line 206
        else if (game->tool == 4) {
            if (_draw(mx, my)) {
                str kind = "fir";
                if (! land_rand(0, 2)) {
                    kind = "eucalypt";
                }
#line 211
                place_tree_rising(t.x, t.y, kind, 1);
            }
        }
    }
#line 213
    trees_tick(game->trees);
#line 215
    if (game->level->done) {
        bool ok = 0;
#line 221
        if (game->trees->healthy >= game->level->required && game->trees->fires == 0 && game->trees->invasives == 0 && game->trees->beetles == 0 && game->trees->hidden == 0) {
            ok = 1;
        }
#line 223
        if (game->countdown) {
            if (ok) {
                game->countdown--;
                if (game->countdown == 0) {
                    game->won = 1;
                    pause_toggle();
                }
            }
#line 228
            else {
#line 230
                game->countdown = 0;
            }
        }
#line 230
        else {
#line 232
            if (ok) {
                game->countdown = 180;
            }
        }
    }
}
#line 235
void pause_toggle(void) {
    game->paused = ! game->paused;
    if (game->won && ! game->paused) {
        game->won = 0;
        game_restart_level(game->level->number + 1);
    }
#line 240
    if (game->paused) {
        music("data/funk.ogg");
    }
#line 241
    else {
#line 243
        music("data/forest.ogg");
    }
    funky(game->paused);
}
static float _letterbox(float * w, float * h) {
    float tw = land_display_width();
    float th = land_display_height();
    float hscale = 16 * 60 / tw;
    * w = tw * hscale;
    * h = th * hscale;
    if (* w / (* h) > 16.0 / 9) {
        float vscale = 9 * 60 / th;
        * w = tw * vscale;
        * h = th * vscale;
        return vscale;
    }
#line 258
    return hscale;
}
void game_draw(void) {
    float w, h;
    float s = _letterbox(& w, & h);
#line 264
    if (game->resizing) {
        game->resizing = 0;
        reload_font(s);
    }
    land_clear(0.5, 0.5, 0.5, 1);
    land_clear_depth(1);
    land_render_state(LAND_DEPTH_TEST, 1);
#line 274
    land_projection(land_4x4_matrix_mul(land_4x4_matrix_orthographic(- w / 2, - h / 2, 1000, w / 2, h / 2, - 1000), land_4x4_matrix_rotate(1, 0, 0, game->camera_angle)));
#line 276
    if (game->paused) {
        float a = land_get_ticks() % 60;
        a = a * 2 * pi / 60;
#line 280
        mesh_draw(game->world->mesh, land_4x4_matrix_translate(cos(a) * 10, sin(a) * 10, 0));
    }
#line 280
    else {
#line 282
        mesh_draw(game->world->mesh, land_4x4_matrix_translate(0, 0, 0));
    }
#line 283
    trees_draw(game->trees);
#line 285
    Land4x4Matrix matrix = land_4x4_matrix_identity();
    land_projection(land_4x4_matrix_orthographic(- w / 2, - h / 2, 1000, w / 2, h / 2, - 1000));
    land_display_transform_4x4(& matrix);
    land_render_state(LAND_DEPTH_TEST, 0);
#line 290
    land_color(0.2, 0.2, 0.2, 0.2);
    land_filled_rectangle(- 480, - h, - 480 + 68, h);
#line 293
    for (int i = 0; i < 8; i += 1) {
        land_color(0.5, 0.5, 0.5, 0.5);
        float x = - 480 + 8;
        float y = h / 2 - i * 60 - 60;
        if ((i < 5 && game->level->tools [i]) || i >= 6) {
            land_filled_rectangle(x, y, x + 52, y + 52);
        }
#line 299
        if (i == 0 && game->level->tools [0]) {
            land_color(0, 0, 1, 1);
            land_filled_circle(x + 10, y + 10, x + 52 - 10, y + 52 - 10);
        }
#line 302
        if (i == 1 && game->level->tools [1]) {
            land_color(1, 1, 1, 1);
            land_filled_circle(x + 10, y + 10, x + 52 - 10, y + 52 - 10);
        }
#line 305
        if (i == 2 && game->level->tools [2]) {
            land_color(1, 0, 0, 1);
            land_filled_circle(x + 10, y + 10, x + 52 - 10, y + 52 - 10);
        }
#line 308
        if (i == 3 && game->level->tools [3]) {
            land_color(0, 1, 0, 1);
            land_filled_circle(x + 10, y + 10, x + 52 - 10, y + 52 - 10);
        }
#line 311
        if (i == 4 && game->level->tools [4]) {
            land_color(0, 0.5, 0, 1);
            land_filled_triangle(x + 10, y + 10, x + 26, y + 52 - 10, x + 52 - 10, y + 10);
        }
#line 314
        if (i == 6) {
            land_color(1, 1, 1, 1);
            land_text_pos(x + 26, y + 20);
            land_print_middle("R");
        }
#line 318
        if (i == 7) {
            land_color(1, 1, 1, 1);
            land_filled_rectangle(x + 10, y + 10, x + 20, y + 52 - 10);
            land_filled_rectangle(x + 52 - 20, y + 10, x + 52 - 10, y + 52 - 10);
        }
        if (i < 5 && game->level->tools [i] > 0) {
            land_color(1, 1, 1, 1);
            land_text_pos(x + 26, y + 26);
            land_print_center("%d", game->level->tools [i]);
        }
    }
#line 328
    land_color(1, 0.8, 0.1, 1);
    land_text_pos(0, h / 2 - 8);
    if (game->won) {
        if (game->trees->lost == 0) {
            land_print_center("You lost not a single tree!");
            land_print_center("Awesome! You're Dr. Forest!");
        }
#line 334
        if (game->trees->lost == 1) {
            land_print_center("You lost only a single tree!");
            land_print_center("Excellent job!");
        }
#line 337
        if (game->trees->lost > 1) {
#line 339
            land_print_center("You lost %d trees but saved the forest!", game->trees->lost);
            land_print_center("Good job!");
        }
    }
#line 340
    else {
#line 343
        land_print_center("%s", game->level->name);
    }
    if (1) {
        int hn = game->trees->healthy;
        int rn = game->level->required;
        if (hn >= rn) {
            land_color(0.3, 0.6, 0, 1);
        }
#line 349
        else {
#line 351
            land_color(1, 0, 0, 1);
        }
#line 352
        land_text_pos(0, - h / 2 + 32);
        land_print_center("%d / %d trees are healthy", hn, rn);
    }
    if (game->trees->fires) {
        land_color(1, 0, 0, 1);
        land_text_pos(480, - h / 2 + 32);
        land_print_right("%d fires!", game->trees->fires);
    }
    if (game->trees->burning) {
        if (! game->fire_p) {
            land_sound_loop(game->fire, 1, 0, 1);
            game->fire_p = 1;
        }
    }
#line 363
    else {
#line 365
        if (game->fire_p) {
            land_sound_stop(game->fire);
            game->fire_p = 0;
        }
    }
#line 369
    if (game->trees->beetles) {
        land_color(1, 1, 0, 1);
        land_text_pos(480, - h / 2 + 32 * 2);
#line 373
        land_print_right("%d beetle%s!", game->trees->beetles, game->trees->beetles == 1 ? "" : "s");
    }
    if (game->trees->invasives) {
        land_color(1, 0.5, 1, 1);
        land_text_pos(480, - h / 2 + 32 * 3);
        land_print_right("%d invasives!", game->trees->invasives);
    }
    if (game->paused) {
        draw_funk();
    }
}
#line 383
void game_done(void) {
#line 383
    ;
}
#line 389
Funk funk [20];
int funkt;
#line 392
void funky(bool start) {
    if (start) {
        funkt = land_get_ticks();
    }
#line 395
    int b = (land_get_ticks() - funkt) % 60;
    if (b == 0) {
        for (int i = 0; i < 20; i += 1) {
            Funk * f = funk + i;
            f->c = land_color_rgba(0, 0, 0, 0);
        }
    }
#line 400
    if (b == 30) {
        for (int i = 0; i < 20; i += 1) {
            Funk * f = funk + i;
            f->x = land_rnd(- 400, 400);
            f->y = land_rnd(- 400, 400);
            f->r = land_rnd(50, 150);
            f->c = land_color_hsv(land_rnd(0, 360), 1, 1);
            f->c = land_color_premul(f->c.r, f->c.g, f->c.b, 0.1);
        }
    }
#line 408
    if (b > 30) {
        for (int i = 0; i < 20; i += 1) {
            Funk * f = funk + i;
            f->x *= 1.005;
            f->y *= 1.005;
        }
    }
}
#line 414
void draw_funk(void) {
    for (int i = 0; i < 20; i += 1) {
        Funk * f = funk + i;
        land_color_set(f->c);
        land_filled_circle(f->x - f->r, f->y - f->r, f->x + f->r, f->y + f->r);
    }
}
/* This file was generated by scramble.py. */
