/* This file was generated by scramble.py. */
#line 1 "src/mesh.py"
#include "mesh.h"
#line 10
LandVector light = {- 1, - 1, 1};
static void _colorize(LandCSG * csg, LandColor rgba);
#line 12
Mesh* mesh_make(str name) {
    Mesh * mesh;
    land_alloc(mesh);
    mesh->name = land_strdup(name);
    mesh->triangles = land_triangles_new();
    return mesh;
}
void mesh_destroy(Mesh * self) {
    if (self->frames) {
        {
#line 21
            LandArrayIterator __iter0__ = LandArrayIterator_first(self->frames);
#line 21
            for (Mesh * m = LandArrayIterator_item(self->frames, &__iter0__); LandArrayIterator_next(self->frames, &__iter0__); m = LandArrayIterator_item(self->frames, &__iter0__)) {
                if (m != self) {
                    mesh_destroy(m);
                }
            }
        }
#line 24
        land_array_destroy(self->frames);
    }
#line 25
    land_triangles_destroy(self->triangles);
    land_free(self->name);
    land_free(self);
}
static void _colorize(LandCSG * csg, LandColor rgba) {
    {
#line 30
        LandArrayIterator __iter0__ = LandArrayIterator_first(csg->polygons);
#line 30
        for (LandCSGPolygon * p = LandArrayIterator_item(csg->polygons, &__iter0__); LandArrayIterator_next(csg->polygons, &__iter0__); p = LandArrayIterator_item(csg->polygons, &__iter0__)) {
            {
#line 31
                LandArrayIterator __iter1__ = LandArrayIterator_first(p->vertices);
#line 31
                for (LandCSGVertex * v = LandArrayIterator_item(p->vertices, &__iter1__); LandArrayIterator_next(p->vertices, &__iter1__); v = LandArrayIterator_item(p->vertices, &__iter1__)) {
                    LandFloat d = land_vector_dot(v->normal, light);
                    LandFloat b = (1 + d) / 2;
                    v->rgba = land_color_premul(rgba.r * b, rgba.g * b, rgba.b * b, 1);
                }
            }
        }
    }
}
#line 36
void mesh_add_anim(Mesh * mesh, Mesh * anim) {
    if (! mesh->frames) {
        mesh->frames = land_array_new();
    }
#line 39
    land_array_add(mesh->frames, anim);
}
void mesh_add(Mesh * mesh, str what, LandColor rgba, Land4x4Matrix matrix) {
    LandCSG * csg = NULL;
    if (land_equals(what, "ball")) {
        csg = csg_sphere(8, 8, NULL);
    }
    if (land_equals(what, "cylinder")) {
        csg = csg_cylinder(6, NULL);
    }
    if (land_equals(what, "cone")) {
        csg = csg_cone(6, NULL);
    }
    land_csg_transform(csg, matrix);
#line 54
    _colorize(csg, rgba);
    land_csg_triangles(csg);
    mesh_add_csg(mesh, csg);
}
void mesh_add_csg(Mesh * self, LandCSG * csg) {
    {
#line 59
        LandArrayIterator __iter0__ = LandArrayIterator_first(csg->polygons);
#line 59
        for (LandCSGPolygon * t = LandArrayIterator_item(csg->polygons, &__iter0__); LandArrayIterator_next(csg->polygons, &__iter0__); t = LandArrayIterator_item(csg->polygons, &__iter0__)) {
            for (int j = 0; j < 3; j += 1) {
                LandCSGVertex * vec = land_array_get_nth(t->vertices, j);
#line 64
                land_add_vertex(self->triangles, vec->pos.x, vec->pos.y, vec->pos.z, 0, 0, vec->rgba.r, vec->rgba.g, vec->rgba.b, vec->rgba.a);
            }
        }
    }
}
#line 66
void mesh_update_vertex(Mesh * self, int i, float x, float y, float z, float r, float g, float b, float a) {
#line 68
    land_update_vertex(self->triangles, i, x, y, z, 0, 0, r, g, b, a);
}
void mesh_draw(Mesh * mesh, Land4x4Matrix matrix) {
    land_display_transform_4x4(& matrix);
    land_triangles_draw(mesh->triangles);
}
/* This file was generated by scramble.py. */
