/* This file was generated by scramble.py. */
#line 1 "src/trees.py"
#ifndef _TREES_
#define _TREES_
typedef struct Tree Tree;
typedef struct Trees Trees;
#line 1
#include "mesh.h"
#include "make.h"
#line 4
struct Tree {
    Mesh * mesh;
    Land4x4Matrix pos;
    bool whirl;
    bool sink;
    bool blighted;
    LandVector v;
    LandVector rot;
    bool alive;
    int burning;
    int frame;
    int sick;
    bool rising;
    bool dancing;
    bool beetle;
    bool invasive;
    float angle;
    Land4x4Matrix dance;
    Tree * target;
    int rest;
    bool pregnant;
    bool infested;
    int hungry;
    int water;
};
struct Trees {
    LandArray * trees /* Tree */;
    LandHash * kinds_by_name /* Mesh */;
#line 33
    LandArray * particles;
    int particle_counter;
#line 36
    LandColor color;
    Land4x4Matrix m;
    int st;
    Land4x4Matrix stack [16];
    Mesh * mesh;
#line 42
    int healthy;
    int lost;
    int beetles;
    int invasives;
    int fires;
    int hidden;
    int burning;
#line 50
    Tree * found;
    int hungry;
};
#define PC 1000
#define M Land4x4Matrix
#define F LandFloat
#define mul land_4x4_matrix_mul
#define tra land_4x4_matrix_translate
#line 61
Trees* trees_new(void);
#line 75
void trees_clear(Trees * self);
#line 86
Tree* trees_make(Trees * trees, str name, float x, float y, float z);
#line 104
void trees_particle(Trees * trees, str kind, float x, float y, float z);
#line 123
void trees_draw(Trees * trees);
#line 134
void trees_callback(Trees * trees, float x, float y, float radius, void(* cb)(Trees * trees, Tree *, float, float));
#line 144
void trees_callback_square(Trees * trees, float x, float y, float radius, void(* cb)(Trees * trees, Tree *, float, float));
#line 153
void tree_whirl(Trees * trees, Tree * tree, float dx, float dy);
#line 167
void tree_burn(Trees * trees, Tree * tree, float dx, float dy);
#line 173
void tree_spread_fire(Trees * trees, Tree * tree, float dx, float dy);
#line 179
void tree_sink(Trees * trees, Tree * tree, float dx, float dy);
#line 183
void tree_water(Trees * trees, Tree * tree, float dx, float dy);
#line 195
void tree_sicken(Trees * trees, Tree * tree, float dx, float dy);
#line 204
void tree_blight(Trees * trees, Tree * tree, float dx, float dy);
#line 211
void tree_infest(Trees * trees, Tree * tree, float dx, float dy);
#line 220
void tree_flag(Trees * trees, Tree * tree, float dx, float dy);
#line 223
void trees_dance(Trees * trees);
#line 250
void trees_tick(Trees * trees);
#endif
/* This file was generated by scramble.py. */
